Index: uspace/lib/posix/include/posix/time.h
===================================================================
--- uspace/lib/posix/include/posix/time.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/posix/include/posix/time.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -37,4 +37,8 @@
 #define POSIX_TIME_H_
 
+#ifndef __POSIX_DEF__
+#define __POSIX_DEF__(x) x
+#endif
+
 #include "sys/types.h"
 
@@ -47,63 +51,69 @@
 #ifndef __locale_t_defined
 	#define __locale_t_defined
-	typedef struct __posix_locale *locale_t;
+	typedef struct __posix_locale *__POSIX_DEF__(locale_t);
+	#ifndef LIBPOSIX_INTERNAL
+		#define locale_t __POSIX_DEF__(locale_t)
+	#endif
 #endif
 
 #ifndef POSIX_SIGNAL_H_
-	struct sigevent;
+	struct __POSIX_DEF__(sigevent);
+	#ifndef LIBPOSIX_INTERNAL
+		#define sigevent __POSIX_DEF__(sigevent)
+	#endif
 #endif
 
 #undef CLOCK_REALTIME
-#define CLOCK_REALTIME ((clockid_t) 0)
+#define CLOCK_REALTIME ((__POSIX_DEF__(clockid_t)) 0)
 
-struct timespec {
+struct __POSIX_DEF__(timespec) {
 	time_t tv_sec; /* Seconds. */
 	long tv_nsec; /* Nanoseconds. */
 };
 
-struct itimerspec {
-	struct timespec it_interval; /* Timer period. */
-	struct timespec it_value; /* Timer expiration. */
+struct __POSIX_DEF__(itimerspec) {
+	struct __POSIX_DEF__(timespec) it_interval; /* Timer period. */
+	struct __POSIX_DEF__(timespec) it_value; /* Timer expiration. */
 };
 
-typedef struct __posix_timer *timer_t;
+typedef struct __posix_timer *__POSIX_DEF__(timer_t);
 
 /* Timezones */
-extern int daylight;
-extern long timezone;
-extern char *tzname[2];
-extern void tzset(void);
+extern int __POSIX_DEF__(daylight);
+extern long __POSIX_DEF__(timezone);
+extern char *__POSIX_DEF__(tzname)[2];
+extern void __POSIX_DEF__(tzset)(void);
 
 /* Time */
-extern time_t time(time_t *t);
+extern time_t __POSIX_DEF__(time)(time_t *t);
 
 /* Broken-down Time */
-extern struct tm *gmtime_r(const time_t *__restrict__ timer,
+extern struct tm *__POSIX_DEF__(gmtime_r)(const time_t *__restrict__ timer,
     struct tm *__restrict__ result);
-extern struct tm *gmtime(const time_t *__restrict__ timep);
-extern struct tm *localtime_r(const time_t *__restrict__ timer,
+extern struct tm *__POSIX_DEF__(gmtime)(const time_t *__restrict__ timep);
+extern struct tm *__POSIX_DEF__(localtime_r)(const time_t *__restrict__ timer,
     struct tm *__restrict__ result);
-extern struct tm *localtime(const time_t *__restrict__ timep);
+extern struct tm *__POSIX_DEF__(localtime)(const time_t *__restrict__ timep);
 
 /* Formatting Calendar Time */
-extern char *asctime_r(const struct tm *__restrict__ timeptr,
+extern char *__POSIX_DEF__(asctime_r)(const struct tm *__restrict__ timeptr,
     char *__restrict__ buf);
-extern char *asctime(const struct tm *__restrict__ timeptr);
-extern char *ctime_r(const time_t *timer, char *buf);
-extern char *ctime(const time_t *timer);
+extern char *__POSIX_DEF__(asctime)(const struct tm *__restrict__ timeptr);
+extern char *__POSIX_DEF__(ctime_r)(const time_t *timer, char *buf);
+extern char *__POSIX_DEF__(ctime)(const time_t *timer);
 extern time_t time(time_t *t);
 
 /* Clocks */
-extern int clock_getres(clockid_t clock_id,
-    struct timespec *res);
-extern int clock_gettime(clockid_t clock_id,
-    struct timespec *tp);
-extern int clock_settime(clockid_t clock_id,
-    const struct timespec *tp);
-extern int clock_nanosleep(clockid_t clock_id, int flags,
-    const struct timespec *rqtp, struct timespec *rmtp);
+extern int __POSIX_DEF__(clock_getres)(__POSIX_DEF__(clockid_t) clock_id,
+    struct __POSIX_DEF__(timespec) *res);
+extern int __POSIX_DEF__(clock_gettime)(__POSIX_DEF__(clockid_t) clock_id,
+    struct __POSIX_DEF__(timespec) *tp);
+extern int __POSIX_DEF__(clock_settime)(__POSIX_DEF__(clockid_t) clock_id,
+    const struct __POSIX_DEF__(timespec) *tp); 
+extern int __POSIX_DEF__(clock_nanosleep)(__POSIX_DEF__(clockid_t) clock_id, int flags,
+    const struct __POSIX_DEF__(timespec) *rqtp, struct __POSIX_DEF__(timespec) *rmtp);
 
 /* CPU Time */
-extern clock_t clock(void);
+extern __POSIX_DEF__(clock_t) __POSIX_DEF__(clock)(void);
 
 
Index: uspace/lib/posix/include/posix/ucontext.h
===================================================================
--- uspace/lib/posix/include/posix/ucontext.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/posix/include/posix/ucontext.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,24 +36,28 @@
 #define POSIX_UCONTEXT_H_
 
+#ifndef __POSIX_DEF__
+#define __POSIX_DEF__(x) x
+#endif
+
 #include "sys/types.h"
 
-typedef int sig_atomic_t;
-typedef uint32_t sigset_t;
-typedef struct mcontext {
+typedef int __POSIX_DEF__(sig_atomic_t);
+typedef uint32_t __POSIX_DEF__(sigset_t);
+typedef struct __POSIX_DEF__(mcontext) {
 	/* must not be empty to avoid compiler warnings (-pedantic) */
 	int dummy;
-} mcontext_t;
+} __POSIX_DEF__(mcontext_t);
 
-union sigval {
+union __POSIX_DEF__(sigval) {
 	int sival_int;
 	void *sival_ptr;
 };
 
-struct sigevent {
+struct __POSIX_DEF__(sigevent) {
 	int sigev_notify; /* Notification type. */
 	int sigev_signo; /* Signal number. */
-	union sigval sigev_value; /* Signal value. */
-	void (*sigev_notify_function)(union sigval); /* Notification function. */
-	thread_attr_t *sigev_notify_attributes; /* Notification attributes. */
+	union __POSIX_DEF__(sigval) sigev_value; /* Signal value. */
+	void (*sigev_notify_function)(union __POSIX_DEF__(sigval)); /* Notification function. */
+	__POSIX_DEF__(thread_attr_t) *sigev_notify_attributes; /* Notification attributes. */
 };
 
@@ -62,12 +66,12 @@
 	size_t ss_size;
 	int ss_flags;
-} stack_t;
+} __POSIX_DEF__(stack_t);
 
-typedef struct ucontext {
-	struct ucontext *uc_link;
-	sigset_t uc_sigmask;
-	stack_t uc_stack;
-	mcontext_t uc_mcontext;
-} ucontext_t;
+typedef struct __POSIX_DEF__(ucontext) {
+	struct __POSIX_DEF__(ucontext) *uc_link;
+	__POSIX_DEF__(sigset_t) uc_sigmask;
+	__POSIX_DEF__(stack_t) uc_stack;
+	__POSIX_DEF__(mcontext_t) uc_mcontext;
+} __POSIX_DEF__(ucontext_t);
 
 
Index: uspace/lib/posix/include/posix/unistd.h
===================================================================
--- uspace/lib/posix/include/posix/unistd.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/posix/include/posix/unistd.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -37,4 +37,8 @@
 #define POSIX_UNISTD_H_
 
+#ifndef __POSIX_DEF__
+#define __POSIX_DEF__(x) x
+#endif
+
 #include "sys/types.h"
 #include "stddef.h"
@@ -47,45 +51,45 @@
 #define _exit exit
 
-extern char *optarg;
+extern char *__POSIX_DEF__(optarg);
 extern int optind, opterr, optopt;
-extern int getopt(int, char * const [], const char *);
+extern int __POSIX_DEF__(getopt)(int, char * const [], const char *);
 
 /* Environment */
-extern char **environ;
+extern char **__POSIX_DEF__(environ);
 
 /* Sleeping */
-extern unsigned int sleep(unsigned int);
+extern unsigned int __POSIX_DEF__(sleep)(unsigned int);
 
 /* Login Information */
-extern char *getlogin(void);
-extern int getlogin_r(char *name, size_t namesize);
+extern char *__POSIX_DEF__(getlogin)(void);
+extern int __POSIX_DEF__(getlogin_r)(char *name, size_t namesize);
 
 /* Identifying Terminals */
-extern int isatty(int fd);
+extern int __POSIX_DEF__(isatty)(int fd);
 
 /* Working Directory */
-extern char *getcwd(char *buf, size_t size);
-extern int chdir(const char *path);
+extern char *__POSIX_DEF__(getcwd)(char *buf, size_t size);
+extern int __POSIX_DEF__(chdir)(const char *path);
 
 /* Query Memory Parameters */
-extern int getpagesize(void);
+extern int __POSIX_DEF__(getpagesize)(void);
 
 /* Process Identification */
-extern pid_t getpid(void);
-extern uid_t getuid(void);
-extern gid_t getgid(void);
+extern __POSIX_DEF__(pid_t) __POSIX_DEF__(getpid)(void);
+extern __POSIX_DEF__(uid_t) __POSIX_DEF__(getuid)(void);
+extern __POSIX_DEF__(gid_t) __POSIX_DEF__(getgid)(void);
 
 /* File Manipulation */
-extern int close(int fildes);
-extern ssize_t read(int fildes, void *buf, size_t nbyte);
-extern ssize_t write(int fildes, const void *buf, size_t nbyte);
-extern off_t lseek(int fildes,
-    off_t offset, int whence);
-extern int fsync(int fildes);
-extern int ftruncate(int fildes, off_t length);
-extern int rmdir(const char *path);
-extern int unlink(const char *path);
-extern int dup(int fildes);
-extern int dup2(int fildes, int fildes2);
+extern int __POSIX_DEF__(close)(int fildes);
+extern ssize_t __POSIX_DEF__(read)(int fildes, void *buf, size_t nbyte);
+extern ssize_t __POSIX_DEF__(write)(int fildes, const void *buf, size_t nbyte);
+extern __POSIX_DEF__(off_t) __POSIX_DEF__(lseek)(int fildes,
+    __POSIX_DEF__(off_t) offset, int whence);
+extern int __POSIX_DEF__(fsync)(int fildes);
+extern int __POSIX_DEF__(ftruncate)(int fildes, __POSIX_DEF__(off_t) length);
+extern int __POSIX_DEF__(rmdir)(const char *path);
+extern int __POSIX_DEF__(unlink)(const char *path);
+extern int __POSIX_DEF__(dup)(int fildes);
+extern int __POSIX_DEF__(dup2)(int fildes, int fildes2);
 
 /* Standard Streams */
@@ -106,5 +110,5 @@
 #define	W_OK 2 /* Test for write permission. */
 #define	R_OK 4 /* Test for read permission. */
-extern int access(const char *path, int amode);
+extern int __POSIX_DEF__(access)(const char *path, int amode);
 
 /* System Parameters */
@@ -115,5 +119,5 @@
 	_SC_CLK_TCK
 };
-extern long sysconf(int name);
+extern long __POSIX_DEF__(sysconf)(int name);
 
 /* Path Configuration Parameters */
@@ -139,18 +143,18 @@
 	_PC_VDISABLE
 };
-extern long pathconf(const char *path, int name);
+extern long __POSIX_DEF__(pathconf)(const char *path, int name);
 
 /* Creating a Process */
-extern pid_t fork(void);
+extern __POSIX_DEF__(pid_t) __POSIX_DEF__(fork)(void);
 
 /* Executing a File */
-extern int execv(const char *path, char *const argv[]);
-extern int execvp(const char *file, char *const argv[]);
+extern int __POSIX_DEF__(execv)(const char *path, char *const argv[]);
+extern int __POSIX_DEF__(execvp)(const char *file, char *const argv[]);
 
 /* Creating a Pipe */
-extern int pipe(int fildes[2]);
+extern int __POSIX_DEF__(pipe)(int fildes[2]);
 
 /* Issue alarm signal. */
-extern unsigned int alarm(unsigned int);
+extern unsigned int __POSIX_DEF__(alarm)(unsigned int);
 
 #endif /* POSIX_UNISTD_H_ */
Index: uspace/lib/posix/source/ctype.c
===================================================================
--- uspace/lib/posix/source/ctype.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
+++ uspace/lib/posix/source/ctype.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -0,0 +1,132 @@
+/*
+ * Copyright (c) 2011 Jiri Zarevucky
+ * Copyright (c) 2011 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libposix
+ * @{
+ */
+/** @file Character classification.
+ */
+
+#define LIBPOSIX_INTERNAL
+#define __POSIX_DEF__(x) posix_##x
+
+#include "posix/ctype.h"
+
+/**
+ * Checks whether character is a hexadecimal digit.
+ *
+ * @param c Character to inspect.
+ * @return Non-zero if character match the definition, zero otherwise.
+ */
+int posix_isxdigit(int c)
+{
+	return isdigit(c) ||
+	    (c >= 'a' && c <= 'f') ||
+	    (c >= 'A' && c <= 'F');
+}
+
+/**
+ * Checks whether character is a word separator.
+ *
+ * @param c Character to inspect.
+ * @return Non-zero if character match the definition, zero otherwise.
+ */
+int posix_isblank(int c)
+{
+	return c == ' ' || c == '\t';
+}
+
+/**
+ * Checks whether character is a control character.
+ *
+ * @param c Character to inspect.
+ * @return Non-zero if character match the definition, zero otherwise.
+ */
+int posix_iscntrl(int c)
+{
+	return c < 0x20 || c == 0x7E;
+}
+
+/**
+ * Checks whether character is any printing character except space.
+ *
+ * @param c Character to inspect.
+ * @return Non-zero if character match the definition, zero otherwise.
+ */
+int posix_isgraph(int c)
+{
+	return posix_isprint(c) && c != ' ';
+}
+
+/**
+ * Checks whether character is a printing character.
+ *
+ * @param c Character to inspect.
+ * @return Non-zero if character match the definition, zero otherwise.
+ */
+int posix_isprint(int c)
+{
+	return posix_isascii(c) && !posix_iscntrl(c);
+}
+
+/**
+ * Checks whether character is a punctuation.
+ *
+ * @param c Character to inspect.
+ * @return Non-zero if character match the definition, zero otherwise.
+ */
+int posix_ispunct(int c)
+{
+	return !isspace(c) && !isalnum(c) && posix_isprint(c);
+}
+
+/**
+ * Checks whether character is ASCII. (obsolete)
+ *
+ * @param c Character to inspect.
+ * @return Non-zero if character match the definition, zero otherwise.
+ */
+int posix_isascii(int c)
+{
+	return c >= 0 && c < 128;
+}
+
+/**
+ * Converts argument to a 7-bit ASCII character. (obsolete)
+ *
+ * @param c Character to convert.
+ * @return Coverted character.
+ */
+int posix_toascii(int c)
+{
+	return c & 0x7F;
+}
+
+/** @}
+ */
Index: uspace/lib/posix/source/dlfcn.c
===================================================================
--- uspace/lib/posix/source/dlfcn.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
+++ uspace/lib/posix/source/dlfcn.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -0,0 +1,68 @@
+/*
+ * Copyright (c) 2017 Vojtech Horky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libposix
+ * @{
+ */
+
+#define LIBPOSIX_INTERNAL
+#define __POSIX_DEF__(x) posix_##x
+
+#include "internal/common.h"
+#include "posix/dlfcn.h"
+
+#include "libc/dlfcn.h"
+
+void *posix_dlopen(const char *filename, int flags)
+{
+	if (flags != 0) {
+		fprintf(stderr, "dlopen() not implemented with non-zero flags (%s:%d), something will NOT work.\n", __FILE__, __LINE__);
+	}
+	
+	return dlopen(filename, 0);
+}
+
+void *posix_dlsym(void *handle, const char *symbol)
+{
+	return dlsym(handle, symbol);
+}
+
+int posix_dlclose(void *handle)
+{
+	not_implemented();
+	return 0;
+}
+
+char *posix_dlerror(void)
+{
+	not_implemented();
+	return (char *)"dlerror()";
+}
+
+/** @}
+ */
Index: uspace/lib/posix/source/errno.c
===================================================================
--- uspace/lib/posix/source/errno.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
+++ uspace/lib/posix/source/errno.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -0,0 +1,54 @@
+/*
+ * Copyright (c) 2011 Jiri Zarevucky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libposix
+ * @{
+ */
+/** @file System error numbers.
+ */
+#define LIBPOSIX_INTERNAL
+#define __POSIX_DEF__(x) posix_##x
+
+#include "posix/errno.h"
+
+#include "posix/stdlib.h"
+#include "libc/fibril.h"
+
+static fibril_local int _posix_errno;
+
+int *__posix_errno(void)
+{
+	if (*__errno() != 0) {
+		_posix_errno = posix_abs(*__errno());
+		*__errno() = 0;
+	}
+	return &_posix_errno;
+}
+
+/** @}
+ */
Index: uspace/lib/posix/source/fcntl.c
===================================================================
--- uspace/lib/posix/source/fcntl.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
+++ uspace/lib/posix/source/fcntl.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -0,0 +1,162 @@
+/*
+ * Copyright (c) 2011 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libposix
+ * @{
+ */
+/** @file File control.
+ */
+
+#define LIBPOSIX_INTERNAL
+#define __POSIX_DEF__(x) posix_##x
+
+#include "internal/common.h"
+#include "posix/fcntl.h"
+
+#include "libc/vfs/vfs.h"
+#include "posix/errno.h"
+
+/**
+ * Performs set of operations on the opened files.
+ *
+ * @param fd File descriptor of the opened file.
+ * @param cmd Operation to carry out.
+ * @return Non-negative on success. Might have special meaning corresponding
+ *     to the requested operation.
+ */
+int posix_fcntl(int fd, int cmd, ...)
+{
+	int flags;
+
+	switch (cmd) {
+	case F_DUPFD:
+	case F_DUPFD_CLOEXEC:
+		/* VFS currently does not provide the functionality to duplicate
+		 * opened file descriptor. */
+		// FIXME: implement this once dup() is available
+		errno = ENOTSUP;
+		return -1;
+	case F_GETFD:
+		/* FD_CLOEXEC is not supported. There are no other flags. */
+		return 0;
+	case F_SETFD:
+		/* FD_CLOEXEC is not supported. Ignore arguments and report success. */
+		return 0;
+	case F_GETFL:
+		/* File status flags (i.e. O_APPEND) are currently private to the
+		 * VFS server so it cannot be easily retrieved. */
+		flags = 0;
+		/* File access flags are currently not supported for file descriptors.
+		 * Provide full access. */
+		flags |= O_RDWR;
+		return flags;
+	case F_SETFL:
+		/* File access flags are currently not supported for file descriptors.
+		 * Ignore arguments and report success. */
+		return 0;
+	case F_GETOWN:
+	case F_SETOWN:
+	case F_GETLK:
+	case F_SETLK:
+	case F_SETLKW:
+		/* Signals (SIGURG) and file locks are not supported. */
+		errno = ENOTSUP;
+		return -1;
+	default:
+		/* Unknown command */
+		errno = EINVAL;
+		return -1;
+	}
+}
+
+/**
+ * Open, possibly create, a file.
+ *
+ * @param pathname Path to the file.
+ * @param posix_flags Access mode flags.
+ */
+int posix_open(const char *pathname, int posix_flags, ...)
+{
+	int rc;
+	posix_mode_t posix_mode = 0;
+	if (posix_flags & O_CREAT) {
+		va_list args;
+		va_start(args, posix_flags);
+		posix_mode = va_arg(args, posix_mode_t);
+		va_end(args);
+		(void) posix_mode;
+	}
+
+	if (((posix_flags & (O_RDONLY | O_WRONLY | O_RDWR)) == 0) ||
+	    ((posix_flags & (O_RDONLY | O_WRONLY)) == (O_RDONLY | O_WRONLY)) ||
+	    ((posix_flags & (O_RDONLY | O_RDWR)) == (O_RDONLY | O_RDWR)) ||
+	    ((posix_flags & (O_WRONLY | O_RDWR)) == (O_WRONLY | O_RDWR))) {
+		errno = EINVAL;
+		return -1;
+	}
+
+	int flags = WALK_REGULAR;
+	if (posix_flags & O_CREAT) {
+		if (posix_flags & O_EXCL)
+			flags |= WALK_MUST_CREATE;
+		else
+			flags |= WALK_MAY_CREATE;
+	}
+
+	int mode =
+	    ((posix_flags & O_RDWR) ? MODE_READ | MODE_WRITE : 0) |
+	    ((posix_flags & O_RDONLY) ? MODE_READ : 0) |
+	    ((posix_flags & O_WRONLY) ? MODE_WRITE : 0) |
+	    ((posix_flags & O_APPEND) ? MODE_APPEND : 0);
+
+	int file = rcerrno(vfs_lookup, pathname, flags);
+	if (file < 0)
+		return -1;
+
+	rc = rcerrno(vfs_open, file, mode);
+	if (rc != EOK) {
+		vfs_put(file);
+		return -1;
+	}
+
+	if (posix_flags & O_TRUNC) {
+		if (posix_flags & (O_RDWR | O_WRONLY)) {
+			rc = rcerrno(vfs_resize, file, 0);
+			if (rc != EOK) {
+				vfs_put(file);
+				return -1;
+			}
+		}
+	}
+
+	return file;
+}
+
+/** @}
+ */
+
